# -*- coding: utf-8 -*-
from __future__ import unicode_literals

from django.db import models, migrations


class Migration(migrations.Migration):

    dependencies = [
    ]

    operations = [
        migrations.CreateModel(
            name='Activity',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('title', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='DiseaseStage',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('stage', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='ElectronicMedicalReport',
            fields=[
                ('report_key', models.CharField(max_length=200, serialize=False, primary_key=True)),
                ('report_class', models.CharField(max_length=200)),
                ('check_date', models.DateField(null=True)),
                ('report_date', models.DateField(null=True)),
                ('report_code', models.CharField(max_length=200)),
                ('report', models.TextField(null=True)),
                ('saved', models.DateField(auto_now=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Followup',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('date', models.DateField()),
                ('memo', models.CharField(max_length=200, null=True, blank=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='ICD9Diag',
            fields=[
                ('code', models.CharField(max_length=5, serialize=False, primary_key=True)),
                ('desc', models.CharField(max_length=50)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Lesion',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('dimensions', models.CharField(max_length=200)),
                ('volume', models.DecimalField(max_digits=9, decimal_places=2)),
                ('plan_name', models.CharField(max_length=200, null=True, blank=True)),
                ('collimator', models.CharField(max_length=200)),
                ('path_no', models.IntegerField()),
                ('beam_no', models.IntegerField()),
                ('mu_max', models.DecimalField(max_digits=9, decimal_places=2)),
                ('mu_min', models.DecimalField(max_digits=9, decimal_places=2)),
                ('dose', models.IntegerField()),
                ('fractions', models.IntegerField()),
                ('iso_dose_curve', models.IntegerField()),
                ('dmin', models.DecimalField(max_digits=9, decimal_places=2)),
                ('dmax', models.DecimalField(max_digits=9, decimal_places=2)),
                ('coverage', models.DecimalField(max_digits=9, decimal_places=2)),
                ('ci', models.DecimalField(max_digits=9, decimal_places=2)),
                ('nci', models.DecimalField(max_digits=9, decimal_places=2)),
                ('start_date', models.DateField(null=True, blank=True)),
                ('end_date', models.DateField(null=True, blank=True)),
                ('memo', models.CharField(max_length=200, null=True, blank=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='LesionFollow',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('Date', models.DateField(verbose_name=b'\xe8\xbf\xbd\xe8\xb9\xa4\xe6\x97\xa5\xe6\x9c\x9f')),
                ('Volume', models.FloatField(null=True, verbose_name=b'\xe9\xab\x94\xe7\xa9\x8d(mm3)')),
                ('A', models.FloatField(null=True, verbose_name=b'\xe9\x95\xb7(mm)')),
                ('B', models.FloatField(null=True, verbose_name=b'\xe5\xaf\xac(mm)')),
                ('C', models.FloatField(null=True, verbose_name=b'\xe9\xab\x98(mm)')),
                ('Memo', models.CharField(max_length=200, null=True, blank=True)),
                ('Lesion', models.ForeignKey(to='ck.Lesion')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='MedicalRecord',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('Record', models.CharField(max_length=200, null=True)),
                ('HospName', models.CharField(max_length=200, null=True)),
                ('DeptName', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\xa7\x91')),
                ('InDate', models.DateField(verbose_name=b'\xe5\x85\xa5')),
                ('OutDate', models.DateField(null=True, verbose_name=b'\xe5\x87\xba')),
                ('WardName', models.CharField(max_length=200, null=True, verbose_name=b'\xe6\x88\xbf')),
                ('RoomName', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\xae\xa4')),
                ('BedName', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\xba\x8a')),
                ('MainDrName', models.CharField(max_length=200, null=True, verbose_name=b'\xe4\xb8\xbb\xe6\xb2\xbb')),
                ('MainDiagnosisName', models.CharField(max_length=200, null=True, verbose_name=b'\xe8\xa8\xba\xe6\x96\xb7')),
                ('StatusName', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\x8b\x80\xe6\x85\x8b')),
                ('SpecialCureName', models.CharField(max_length=200, null=True, verbose_name=b'\xe8\xa1\x8c\xe7\x82\xba')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Oncologist',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('name', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='OPNote',
            fields=[
                ('key_code', models.CharField(max_length=200, serialize=False, primary_key=True)),
                ('key_name', models.CharField(max_length=200)),
                ('doc', models.TextField(null=True, verbose_name=b'\xe6\x91\x98')),
                ('saved', models.DateField(auto_now=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='PACSImage',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('PatChartNo', models.CharField(max_length=200, verbose_name=b'\xe7\x97\x85\xe6\xad\xb7\xe8\x99\x9f')),
                ('RequestSheetNo', models.CharField(max_length=200, verbose_name=b'\xe5\x96\xae\xe8\x99\x9f')),
                ('ExamDate', models.DateField(verbose_name=b'\xe6\xaa\xa2\xe6\x9f\xa5\xe6\x97\xa5')),
                ('LinkOrderName', models.CharField(max_length=200, verbose_name=b'\xe6\xaa\xa2\xe6\x9f\xa5\xe5\x90\x8d\xe7\xa8\xb1')),
                ('Modality', models.CharField(max_length=200, verbose_name=b'\xe5\x84\x80\xe5\x99\xa8')),
                ('VerifiedStateString', models.CharField(max_length=200, verbose_name=b'\xe7\x8b\x80\xe6\x85\x8b')),
                ('Exam', models.TextField(null=True, verbose_name=b'\xe5\xa0\xb1\xe5\x91\x8a\xe5\x85\xa7\xe5\xae\xb9')),
                ('Impression', models.TextField(null=True)),
                ('Report', models.TextField(null=True, verbose_name=b'\xe5\xa0\xb1\xe5\x91\x8a')),
                ('Saved', models.IntegerField(verbose_name=b'\xe4\xbf\x9d\xe5\xad\x98', choices=[(0, b'\xe5\xbe\x85\xe8\x99\x95\xe7\x90\x86'), (10, b'\xe6\x9c\x89\xe8\xbc\xb8\xe5\x85\xa5'), (15, b'\xe5\xb7\xb2\xe7\xa2\xba\xe8\xaa\x8d'), (20, b'\xe4\xb8\x8d\xe9\x81\xa9\xe7\x94\xa8')])),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='PathExam',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('path_code', models.CharField(unique=True, max_length=200, verbose_name=b'\xe7\x97\x85\xe7\x90\x86\xe8\x99\x9f')),
                ('specimen_code', models.CharField(max_length=200, verbose_name=b'\xe6\xaa\xa2\xe9\xab\x94')),
                ('specimen_get_date', models.DateField(verbose_name=b'\xe6\x94\xb6\xe4\xbb\xb6\xe6\x97\xa5')),
                ('report_date', models.DateField(verbose_name=b'\xe5\xa0\xb1\xe5\x91\x8a\xe6\x97\xa5')),
                ('division', models.CharField(max_length=200, verbose_name=b'\xe7\xa7\x91\xe5\x88\xa5')),
                ('bed', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\x97\x85\xe5\xba\x8a', blank=True)),
                ('report', models.TextField(null=True, verbose_name=b'\xe6\xaa\xa2\xe6\x9f\xa5\xe5\xa0\xb1\xe5\x91\x8a', blank=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Pathology',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('pathology', models.CharField(unique=True, max_length=200)),
                ('stage', models.ForeignKey(to='ck.DiseaseStage')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Patient',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('name', models.CharField(max_length=200, verbose_name=b'\xe5\xa7\x93\xe5\x90\x8d')),
                ('medical_records', models.CharField(unique=True, max_length=200)),
                ('gender', models.IntegerField(choices=[(1, b'Male'), (2, b'Female')])),
                ('birthday', models.DateField()),
                ('address', models.CharField(max_length=200)),
                ('phone', models.CharField(max_length=200)),
                ('id_cards', models.CharField(unique=True, max_length=200)),
                ('memo', models.CharField(max_length=200, null=True, blank=True)),
                ('dead', models.DateField(null=True, blank=True)),
                ('height', models.DecimalField(null=True, max_digits=4, decimal_places=1)),
                ('weight', models.DecimalField(null=True, max_digits=6, decimal_places=3)),
                ('native', models.CharField(max_length=200, null=True, blank=True)),
                ('past_and_family_history', models.TextField(null=True, blank=True)),
                ('timestamp', models.DateTimeField(auto_now=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='PatientMedicalRecord',
            fields=[
                ('key_code', models.CharField(max_length=200, serialize=False, primary_key=True)),
                ('key_name', models.CharField(max_length=200)),
                ('hosp_name', models.CharField(max_length=200, null=True)),
                ('dept_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\xa7\x91')),
                ('in_date', models.DateField(null=True, verbose_name=b'\xe5\x85\xa5')),
                ('out_date', models.DateField(null=True, verbose_name=b'\xe5\x87\xba')),
                ('ward_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe6\x88\xbf')),
                ('room_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\xae\xa4')),
                ('bed_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\xba\x8a')),
                ('come_clinic_date', models.DateField(null=True, verbose_name=b'\xe6\x8e\x9b\xe8\x99\x9f\xe6\x97\xa5')),
                ('discharge_date', models.DateField(null=True, verbose_name=b'\xe9\x9b\xa2\xe9\x83\xa8\xe6\x97\xa5')),
                ('special_cure_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe8\xa1\x8c\xe7\x82\xba')),
                ('main_dr_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe4\xb8\xbb\xe6\xb2\xbb')),
                ('main_diagnosis_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe8\xa8\xba\xe6\x96\xb7')),
                ('status_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\x8b\x80\xe6\x85\x8b')),
                ('temp_bed_id', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\xba\x8a')),
                ('account_status_name', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\x8b\x80\xe6\x85\x8b')),
                ('func', models.CharField(max_length=200, null=True)),
                ('doc', models.TextField(null=True, verbose_name=b'\xe6\x91\x98')),
                ('saved', models.DateField(auto_now=True)),
                ('patient', models.ForeignKey(to='ck.Patient')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Price',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('code', models.CharField(max_length=200, null=True, blank=True)),
                ('identity', models.IntegerField(choices=[(10, b'\xe5\x81\xa5\xe4\xbf\x9d'), (20, b'\xe8\x87\xaa\xe8\xb2\xbb'), (30, b'\xe5\x85\xa7\xe5\x90\xab')])),
                ('name', models.CharField(max_length=200)),
                ('unit', models.CharField(max_length=200, null=True, blank=True)),
                ('address', models.IntegerField(null=True, blank=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='PrimaryTumorSite',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('site', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='PriorTreatment',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('date', models.DateField()),
                ('treatment', models.IntegerField(choices=[(1, b'Surgery'), (2, b'Biopsy'), (3, b'RT'), (4, b'Radiosurgery'), (5, b'Chemotherapy')])),
                ('period', models.IntegerField(blank=True, null=True, choices=[(1, b'Before'), (2, b'Concurrent'), (3, b'None')])),
                ('dose', models.IntegerField(null=True, blank=True)),
                ('memo', models.CharField(max_length=200, null=True, blank=True)),
                ('patient', models.ForeignKey(to='ck.Patient')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='SubLocation',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('group', models.IntegerField()),
                ('sub_location', models.CharField(max_length=200)),
                ('pathology', models.ManyToManyField(to='ck.Pathology')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Surgeon',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('name', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='TargetLocation',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('location', models.CharField(max_length=200)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='Treatment',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('bed', models.CharField(max_length=200, null=True, verbose_name=b'\xe7\x97\x85\xe5\xba\x8a\xe8\x99\x9f', blank=True)),
                ('other_diagnosis', models.CharField(max_length=200, null=True, verbose_name=b'\xe5\x85\xb6\xe4\xbb\x96\xe8\xa8\xba\xe6\x96\xb7', blank=True)),
                ('tracking_mode', models.IntegerField(blank=True, null=True, choices=[(100, b'6D Skull'), (200, b'Xsight-Spine'), (210, b'Xsight-Lung'), (300, b'Fiducial'), (400, b'Synchrony')])),
                ('referral', models.CharField(max_length=200, null=True, verbose_name=b'\xe8\xbd\x89\xe4\xbb\x8b\xe9\x86\xab\xe5\xb8\xab', blank=True)),
                ('date_started', models.DateField(null=True, blank=True)),
                ('date_completed', models.DateField(null=True, blank=True)),
                ('accounting', models.IntegerField(blank=True, null=True, verbose_name=b'\xe8\xa8\x98\xe5\xb8\xb3\xe5\x88\xa5', choices=[(10, b'\xe5\x81\xa5\xe4\xbf\x9d'), (20, b'\xe8\x87\xaa\xe8\xb2\xbb'), (30, b'\xe5\x85\xa7\xe5\x90\xab')])),
                ('karnofsky_score', models.IntegerField(blank=True, null=True, choices=[(100, b'100% - normal, no complaints, no signs of disease'), (90, b' 90% - capable of normal activity, few symptoms or signs of disease'), (80, b' 80% - normal activity with some difficulty, some symptoms or signs'), (70, b' 70% - caring for self, not capable of normal activity or work'), (60, b' 60% - requiring some help, can take care of most personal requirements'), (50, b' 50% - requires help often, requires frequent medical care'), (40, b' 40% - disabled, requires special care and help'), (30, b' 30% - severely disabled, hospital admission indicated but no risk of death'), (20, b' 20% - very ill, urgently requiring admission, requires supportive measures or treatment'), (10, b' 10% - moribund, rapidly progressive fatal disease processes'), (0, b'  0% - death')])),
                ('complications', models.CharField(max_length=200, null=True, verbose_name=b'\xe4\xbd\xb5\xe7\x99\xbc\xe7\x97\x87', blank=True)),
                ('chief_complaint', models.TextField(null=True, blank=True)),
                ('memo', models.CharField(max_length=200, null=True, blank=True)),
                ('timestamp', models.DateTimeField(auto_now=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='TreatmentResponse',
            fields=[
                ('treatment', models.ForeignKey(primary_key=True, serialize=False, to='ck.Treatment')),
                ('time', models.DateField(null=True)),
                ('event', models.NullBooleanField()),
                ('time1y', models.DateField(null=True)),
                ('event1y', models.NullBooleanField()),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='VEVENT',
            fields=[
                ('id', models.AutoField(verbose_name='ID', serialize=False, auto_created=True, primary_key=True)),
                ('DTSTAMP', models.DateTimeField(auto_now=True)),
                ('DTSTART', models.DateTimeField()),
                ('DTEND', models.TimeField(blank=True)),
                ('DURATION', models.TimeField()),
                ('SUMMARY', models.CharField(max_length=200, null=True, blank=True)),
                ('CLASS', models.CharField(max_length=200, null=True, blank=True)),
                ('CATEGORIES', models.CharField(max_length=200, null=True, blank=True)),
                ('TRANSP', models.CharField(max_length=200, null=True, blank=True)),
                ('RRULE', models.CharField(max_length=200, null=True, blank=True)),
                ('DESCRIPTION', models.CharField(max_length=200, null=True, blank=True)),
                ('mode', models.IntegerField(choices=[(110, b'Fiducial'), (200, b'\xe5\x9b\xba\xe5\xae\x9a\xe5\x99\xa8'), (210, b'CT'), (220, b'MRI'), (230, b'Angio'), (310, b'\xe6\xb2\xbb\xe7\x99\x82')])),
                ('break_frequency', models.IntegerField(blank=True)),
                ('system_err', models.IntegerField(blank=True)),
                ('shift', models.IntegerField(blank=True)),
                ('cone', models.IntegerField(blank=True)),
                ('path', models.IntegerField(blank=True)),
                ('price', models.ForeignKey(blank=True, to='ck.Price', null=True)),
                ('treatment', models.ForeignKey(to='ck.Treatment')),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.CreateModel(
            name='XrayTextReport',
            fields=[
                ('report_key', models.ForeignKey(primary_key=True, serialize=False, to='ck.ElectronicMedicalReport')),
                ('old_access_no', models.CharField(max_length=200, null=True)),
                ('ioe', models.CharField(max_length=200, null=True)),
                ('refer_dept', models.CharField(max_length=200, null=True)),
                ('status', models.CharField(max_length=200, null=True)),
                ('formal_version', models.CharField(max_length=200, null=True)),
                ('exam_date', models.DateField(null=True)),
                ('order_desc', models.CharField(max_length=200, null=True)),
                ('clean_html', models.TextField(null=True)),
                ('response', models.CharField(max_length=200, null=True)),
            ],
            options={
            },
            bases=(models.Model,),
        ),
        migrations.AddField(
            model_name='treatment',
            name='disease_stage',
            field=models.ForeignKey(blank=True, to='ck.DiseaseStage', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='icd9',
            field=models.ForeignKey(verbose_name=b'ICD9\xe8\xa8\xba\xe6\x96\xb7', blank=True, to='ck.ICD9Diag', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='input',
            field=models.ForeignKey(related_name='input', verbose_name=b'\xe5\xb7\xb2', blank=True, to='ck.Activity', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='oncologist',
            field=models.ForeignKey(blank=True, to='ck.Oncologist', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='output',
            field=models.ForeignKey(related_name='output', verbose_name=b'\xe5\xbe\x85', blank=True, to='ck.Activity', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='primary_tumor_site',
            field=models.ForeignKey(blank=True, to='ck.PrimaryTumorSite', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='treatment',
            name='surgeon',
            field=models.ForeignKey(blank=True, to='ck.Surgeon', null=True),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='sublocation',
            name='target_location',
            field=models.ForeignKey(to='ck.TargetLocation'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='pathexam',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='pacsimage',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='opnote',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='medicalrecord',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='lesion',
            name='pathology',
            field=models.ForeignKey(to='ck.Pathology'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='lesion',
            name='sub_location',
            field=models.ForeignKey(to='ck.SubLocation'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='lesion',
            name='treatment',
            field=models.ForeignKey(to='ck.Treatment'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='followup',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
        migrations.AddField(
            model_name='electronicmedicalreport',
            name='patient',
            field=models.ForeignKey(to='ck.Patient'),
            preserve_default=True,
        ),
    ]
